



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Unix/Linux中的fork函数</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Unix/Linux中的fork函数</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 04:41:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>fork函数介绍</h1>
<p>　　一个现有进程可以调用fork函数创建一个新进程。该函数定义如下：</p>
<div>
<pre class="prettyprint linenums">#include &lt;unistd.h&gt;<br />
pid_t fork(void);<br />
// 返回：若成功则在子进程中返回0，在父进程中返回子进程ID，若出错则返回-1</pre>
</div>
<p>　　fork函数调用一次，返回两次。它在调用进程（称为父进程）中返回一次，返回值是新派生进程（称为子进程）的进程ID号；在子进程中返回一次，返回值为0。因此，返回值本身告知当前进程是子进程还是父进程。</p>
<p>　　fork在子进程返回0而不是父进程的进程ID的原因在于：任何子进程只有一个父进程，而且子进程总是可以通过调用getppid取得父进程的进程ID。相反，父进程可以有很多子进程，而且无法获取各个子进程的进程ID。如果父进程想要跟踪所有子进程的进程ID，那么它必须记录每次调用fork的返回值。另外，进程ID 0总是由内核交换进程使用，所以一个子进程的进程ID不可能为0。</p>
<p>　　子进程和父进程继续执行<strong>fork调用之后</strong>的指令。子进程是父进程的副本。例如，子进程获得父进程数据空间、堆和栈的副本。父、子进程并不共享这些存储空间部分。父、子进程共享代码段。</p>
<p>　　由于在fork之后经常跟随着exec，所以现在的很多实现并不执行一个父进程数据段、堆和栈的完全复制。作为替代，使用了写时复制（Copy-On-Write, COW）技术。这些区域由父、子进程共享，而且内核将它们的访问权限改变为只读的。如果父、子进程中的任一个试图修改这些区域，则内核只为修改区域的那块内存制作一个副本，通常是虚拟存储器系统的一&ldquo;页&rdquo;。</p>
<p>　　使fork失败的两个主要原因是：1）系统中已经有太多的进程（通常意味着某个方面出了问题）；2）实际用户的进程总数超过了系统限制。</p>
<h1>附：exec函数</h1>
<p>　　用fork函数创建子进程后，子进程往往要调用一种exec函数以执行另一个程序。当进程调用一种exec函数时，该进程执行的程序完全替换为新程序，而新程序则从其main函数开始执行。因为调用exec并不创建新进程，所以前后的进程ID并未改变。<strong>exec函数只是用一个全新的程序替换了当前进程的正文、数据、堆和栈端。</strong></p>
<p>　　关于exec函数详细的请参考：</p>
<p>　　APUE 8.10节</p>
<p>　　<a href="http://docs.linuxtone.org/ebooks/C&amp;CPP/c/ch30s03.html" rel="external nofollow noreferrer">进程控制</a></p>
<h1>一个简单的例子</h1>
<p>　　简单示例程序如下：</p>
<div>
<pre class="prettyprint linenums"> #include &lt;unistd.h&gt;<br />
 #include &lt;stdio.h&gt;

 int main()<br />
 {<br />
     pid_t fpid;<br />
     fpid = fork();

     if(fpid &lt; )<br />
     {<br />
         printf("error in fork!");<br />
     }<br />
     else if(fpid == )<br />
     {<br />
         printf("\n=================================================\n");<br />
         printf("I am the child process, my process ID is %d\n", getpid());<br />
         printf("My parent process ID is %d\n", getppid());<br />
         printf("=================================================\n");<br />
     }<br />
     else<br />
     {<br />
         printf("\n=================================================\n");<br />
         printf("I am the parent process, my process ID is %d\n", getpid());<br />
         printf("=================================================\n");<br />
         sleep();<br />
     }

     return ;<br />
 }</pre>
</div>
<p>　　程序的运行结果是：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/570460/201507/031408485952405.png" /></p>
<p>　　按照惯常，程序按顺序执行，最终输出应该只有if...else if...else中一个条件下的结果，但很明显我们这边输出了两个条件下的结果。具体原因在于通过fork函数创建的子进程也会复制父进程的存储空间（数据、堆、栈等，包括程序计数器），创建了属于自己的存储空间，并从fork函数后开始执行。利用pstree命令可以看到子进程（ID 18406）确实继承自父进程（ID 18405）：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/570460/201507/031410133457312.png" /></p>
<p>　　一般来说，在fork之后是父进程先执行还是子进程先执行是不确定的，这取决于内核所使用的调度算法。在上述程序中，父进程先执行，子进程在其之后执行。</p>
<h1>关于fork面试题</h1>
<h2>题目及答案　　</h2>
<p>　　下边的一道题摘自陈皓的<a href="http://coolshell.cn/articles/7965.html" rel="external nofollow noreferrer">博文</a>：</p>
<div>
<pre class="prettyprint linenums"> #include &lt;stdio.h&gt;<br />
 #include &lt;sys/types.h&gt;<br />
 #include &lt;unistd.h&gt;

 int main()<br />
 {<br />
     int i;<br />
     for(i = ; i &lt; ; i++)<br />
     {<br />
         fork();<br />
         printf("-");<br />
     }

     sleep();<br />
     return ;<br />
 }</pre>
</div>
<p>　　请问上述程序会输出几个&lsquo;-&rsquo;？6个还是8个？</p>
<p>　　如果我们不考虑printf函数的缓存效果，程序的最终输出是6个&lsquo;-&rsquo;。但因为printf函数有缓存的效用，最终导致输出了8个&lsquo;-&rsquo;。具体原因可参照陈皓的<a href="http://coolshell.cn/articles/7965.html" rel="external nofollow noreferrer">博文</a>。</p>
<h2>不考虑printf函数缓存效用</h2>
<p>　　为了去除printf函数缓存效用，我们稍微改动一下程序：</p>
<div>
<pre class="prettyprint linenums"> #include &lt;stdio.h&gt;<br />
 #include &lt;sys/types.h&gt;<br />
 #include &lt;unistd.h&gt;

 int main()<br />
 {<br />
     int i;<br />
     for(i = ; i &lt; ; i++)<br />
     {<br />
         fork();<br />
         printf("-\n");<br />
     }

     sleep();<br />
     return ;<br />
 }</pre>
</div>
<p>　　这下输出就正确了。下边两图是程序输出结果和相应的进程（forktest3）树状图：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/570460/201507/031436278216769.png" /></p>
<p>　　<img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/570460/201507/031449375458539.png" /></p>
<h2>更直观的解析</h2>
<p>　　为了更直观，我们可以修改程序如下：</p>
<div>
<pre class="prettyprint linenums"> #include &lt;stdio.h&gt;<br />
 #include &lt;sys/types.h&gt;<br />
 #include &lt;unistd.h&gt;

 int main()<br />
 {<br />
     int i;<br />
     for(i = ; i &lt; ; i++)<br />
     {<br />
         fork();<br />
         printf("ppid=%d, pid=%d, i=%d \n", getppid(), getpid(), i);<br />
     }

     sleep();    //让进程停留十秒，这样我们可以用pstree查看一下进程树<br />
     return ;<br />
 }</pre>
</div>
<p>　　输出结果如下：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/570460/201507/031450440402090.png" /></p>
<p>　　陈皓还给出了图示解释：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://coolshell.cn//wp-content/uploads/2012/07/fork01jpg.jpg" /></p>
<p>　　上图中，相同颜色的是同一个进程。</p>
<p>　　而对于printf("-");这个语句，我们就可以很清楚的知道，哪个子进程复制了父进程标准输出缓中区里的的内容，而导致了多次输出了。如下图所示，就是阴影并双边框了那两个子进程：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://coolshell.cn//wp-content/uploads/2012/07/fork03.jpg" /></p>
<h1>其他可参考资料</h1>
<p>　　<a href="http://www.geekride.com/fork-forking-vs-threading-thread-linux-kernel/" rel="external nofollow noreferrer">Forking vs Threading</a></p>
<p>　　<a href="http://www.cnblogs.com/anker/p/3271773.html" rel="external nofollow noreferrer">孤儿进程与僵尸进程[总结]</a></p>
<p>　　<a href="http://www.cnblogs.com/leoo2sk/archive/2009/12/11/talk-about-fork-in-linux.html" rel="external nofollow noreferrer">从一道面试题谈linux下fork的运行机制</a></p>
<p>　　<a href="https://linux.cn/article-5685-1.html" rel="external nofollow noreferrer">经典的 Fork 炸弹解析</a></p>
<h1>本文参考资料</h1>
<p>　　《UNIX环境高级编程 第二版》</p>
<p>　　<a href="http://coolshell.cn/articles/7965.html" rel="external nofollow noreferrer">一个fork的面试题</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pdlyy9.html">原生js模拟锚点，实现点击后，内容定位到本页的对应位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oll4p8.html">基于MVC4&plus;EasyUI的Web开发框架经验总结（5）--使用HTML编辑控件CKEditor和CKFinder</a>
		</li>
						<li><a href="https://www.batexi.com/a/495nv769.html">在虚拟机中安装CentOS7</a>
		</li>
						<li><a href="https://www.batexi.com/a/390g2l48.html">学习IT资源分享，欢迎各位知道的学习IT资源前来分享</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1nxyk8.html">ASP&period;NET MVC掉过的坑&lowbar;MVC初识及MVC应用程序结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zzknk9.html">開始开发 Dashboard Widgets，第2章，读书笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gekvv08.html">Django 部署到Nginx</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpy1p7q.html">zookeeper3&period;4&period;13集群安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj2k6r9.html">11&period;2-uC&sol;OS-III添加任务到就绪队列</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e422zm9.html">PAT L2-011 玩转二叉树</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj43n79.html">php多进程、IPC和事件驱动</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkyj118.html">在发送信息时应用PendingIntent&period;FLAG&lowbar;UPDATE&lowbar;CURRENT</a>
		</li>
						<li><a href="https://www.batexi.com/a/963dle39.html">&lbrack;&period;net&rsqb;线程基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k3pj3q.html">解析xml文件步骤 -- pullparser</a>
		</li>
						<li><a href="https://www.batexi.com/a/963w4439.html">StrConv 内码转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g3z6mlq.html">centos7&period;1部署java环境服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/90d1gyj8.html">linux下面which whereis find locate的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zv2nwn9.html">VMWare中安装windowsXP遇到的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy2nvk29.html">poj  1185 状压dp&plus;优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/90j2gnm8.html">SpringMVC将url生成二维码图片直接展示在页面上</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv1wwrzq.html">Android获取当前网络状态</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjyy7k8.html">gitlab的搭建及问题的解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eykldm9.html">UNIX环境高级编程&mdash;&mdash;创建孤儿进程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1wmgyq.html">Linux Debugging（八）： core真的那么难以追踪吗？</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkg3wz8.html">Dynamics CRM 窗体Javascript获取时间字段值的准确转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpzed59.html">mac os X下的updatedb</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjexe28.html">【shell点滴】参数变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz73v08.html">安卓中的消息循环机制Handler及Looper详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j1ovx8.html">如何在Cocos2D游戏中实现A&ast;寻路算法&lpar;四&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd5zxy9.html">iOS中 UITabBarController中自定义UITabBar</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
